import java.io.*;
import java.util.*;

public class TorxState {
	byte[] ltsa;
	int number;
	String repr;
	TorxTransition incoming;
	Vector succ;
	boolean exploring = false;

	
	public TorxState(byte[] s) {
		repr = new String();
		for(int i = 0; i< s.length; i++) {
			repr += " " + s[i];
		}
	}
	
	public boolean equals(Object o) {
		if (this == o)
			return true;
		else if ((o != null) && (o instanceof TorxState)) {
			TorxState ts = (TorxState)o;
			return repr.equals(ts.repr);
		} else
			return false;
	}
	public int hashCode() {
		return repr.hashCode();
	}
	
	public int number() {
		return number;
	}
	public byte[] ltsa() {
		return ltsa;
	}
	public void incoming(TorxTransition t) {
		if (incoming == null)
			incoming = t;
	}
	public TorxTransition incoming() {
		return incoming;
	}

	public Vector succ() {
		return succ;
	}

	public String nr() {
		return "S" + number();
	}

	// add outgoing transitions:

	public boolean explored() {
		return (succ != null);
	}
	
	public void explore_start() {
		if (succ != null || exploring)
			System.err.println("assertion failed: TorxState.explore_start");
		else {
			succ = new Vector();
			exploring = true;
		}
	}
	
	public void explore_add(TorxTransition t) {
		if (succ == null || !exploring)
			System.err.println("assertion failed: TorxState.explore_add");
		else
			succ.add(t);
	}

	public void explore_stop() {
		if (succ == null || !exploring)
			System.err.println("assertion failed: TorxState.explore_stop");
		else
			exploring = false;
	}

}
