
/*  A Bison parser, made from spexgram.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	SPEX_OUTPUT	257
#define	SPEX_INPUT	258
#define	SPEX_IO	259
#define	SPEX_CHAN	260
#define	NOW_STRUCT	261
#define	PROC_STRUCT	262
#define	DOMAIN	263
#define	SPEX	264
#define	IN	265
#define	DOTS	266
#define	OF	267
#define	STRING	268
#define	NUMBER	269
#define	OPERAND	270
#define	LOGIC_OR	271
#define	LOGIC_AND	272
#define	OTHER	273
#define	SINGLE_OTHER	274
#define	TYPE	275
#define	MTYPE	276
#define	CHAN	277
#define	PROCTYPE	278
#define	STRUCT_MEMB	279
#define	ARROW	280
#define	AMPERSAND	281

#line 13 "spexgram.y"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define YYERROR_VERBOSE
// #define YYDEBUG 1
 
void yyerror(const char *str);
int yywrap();
int main(void);

int yydebug = 0;
int fatalerr = 0;

extern int lineno;

/*
 * Structs for various rules
 */

typedef struct ident {
	char *str;
	char *name;
	struct exprpart *array_index;
	char *str_ind;
	struct ident *str_part;
} Ident;

struct exprpart {
	// Either 'expr' or 'id' will hold a value, the other should be NULL
	char *expr;
	struct ident *id;
	struct exprpart *next;
};

struct lrangepart {
	char *lb;
	char *ub;
	struct lrangepart *next;
};

struct range {
	struct ident *id;
	struct lrangepart *parts;
};

struct largs {
	struct exprpart *parts;
	struct largs *next;
};

struct lrange {
	struct range *ra;
	struct lrange *next;
};

typedef enum {
	t_range,
	t_arg,
} arg_or_range;
struct largrange {
	arg_or_range t;
	union {
		struct range *ra;
		struct exprpart *parts;
	} u;
	struct largrange *next;
};

struct compare {	
	struct ident *id;
	const char *op;
	struct exprpart *expr;
};

struct cmp_entry {
	char parentheses;
	char or_op;
	struct compare *cmp;
	struct cmp_entry *lhs;
	struct cmp_entry *rhs;
};

struct stringlist {
	char *label;
	struct stringlist *next;
};

struct mtypelist {
	char *label;
	char *intrepr;
	struct mtypelist *next;
};

struct chandecllist {
	char *chan;
	struct stringlist *types;
	struct chandecllist *next;
};

struct id_inst {
	struct ident *id;
	struct exprpart *expart;
	struct id_inst *next;
};

struct arg_list {
	char *type;
	struct id_inst *id_list;
	struct arg_list *next;
};
	
/*
 * Private structs
 */

typedef struct id_entry {
	char *type;
	char *label;
	struct id_entry *next;
} IdEntry;


/* 
 * Private functions
 */
const char *op_recognize(char *);
const char *dhas_op(const char *op);
const char *domain_op(const char *op);

struct exprpart	*expr_append(struct exprpart *, struct exprpart *);
struct exprpart	*expr_string(char *str);
struct exprpart	*args_flatten(struct largs *arguments);
struct largs 	*args_append(struct largs *, struct largs *);
struct lrangepart *num_range_append(struct lrangepart *, struct lrangepart *);
struct lrange 	*lrange_append(struct lrange *, struct lrange *);
struct largrange	*largrange_append(struct largrange *, struct largrange *);

void print_ident(struct ident *, char);
void print_str(struct ident *id);
void print_expr(struct exprpart *, char);

void print_cmpe_cond(struct cmp_entry *cmpe, char c_prefix);
void print_cmpe_eff(struct cmp_entry *cmpe, char c_prefix);
void print_cmpe(struct cmp_entry *cmpe);
void print_cmp(struct compare *cmp, char printStruct);
void print_cmp_cond(struct compare *cmp);
void print_cmp_eff(struct compare *cmp);
void print_cmpe_eff(struct cmp_entry *cmpe, char c_prefix);
void print_cmpe_or_eff(struct cmp_entry *cmpe);
void print_cmpe_and_eff(struct cmp_entry *cmpe);

IdEntry *findId(char *name);
int isRangeBetween(struct lrangepart *, int, int);
char * mtypenr(char *s);
struct stringlist *findchantypes(char *s);

/*
 * Private variables
 */
const char *OP_EQ = "==";
const char *OP_NEQ = "!=";
const char *OP_GTEQ = ">=";
const char *OP_GT = ">";
const char *OP_STEQ = "<=";
const char *OP_ST = "<";

char proctype_seen = 0;
char *last_proctype = NULL;

char *file_name =  NULL;


// Linked list for global identifiers.
IdEntry *glIds = NULL;
IdEntry *curGlId = NULL;
IdEntry *localIds = NULL;
IdEntry *curLclId = NULL;

struct mtypelist *mtypes = NULL;
struct chandecllist  *channels = NULL;


#line 198 "spexgram.y"
typedef union { 
	struct largrange *arl;
	struct lrange *rl;
	struct range *r;
	struct lrangepart *rp;
	struct largs *al;
	struct exprpart *ep;
	struct ident *id;
	struct compare *cmp;
	struct cmp_entry *cmpe;
	struct stringlist *sl;
	struct mtypelist *ml;
	struct id_inst *ids;
	struct arg_list *args;
	char *str;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		226
#define	YYFLAG		-32768
#define	YYNTBASE	38

#define YYTRANSLATE(x) ((unsigned)(x) <= 281 ? yytranslate[x] : 102)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,    28,     2,     2,     2,     2,    29,
    30,     2,     2,    34,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    37,     2,
    32,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    35,     2,    36,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    33,     2,    31,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     7,     9,    11,    13,    15,    17,    19,
    21,    23,    25,    29,    32,    38,    44,    50,    55,    60,
    65,    67,    70,    73,    76,    78,    80,    82,    84,    86,
    88,    90,    97,    99,   103,   104,   106,   117,   128,   131,
   134,   137,   142,   144,   148,   150,   154,   156,   160,   162,
   166,   168,   170,   172,   174,   176,   180,   181,   188,   189,
   191,   193,   197,   200,   202,   206,   208,   210,   212,   214,
   216,   218,   220,   222,   224,   226,   228,   230,   232,   234,
   236,   238,   240,   242,   244,   246,   248,   250,   251,   254,
   256,   260,   263,   265,   266,   269,   271,   275,   281,   283,
   285,   289,   291,   295,   296,   299,   301,   305,   307,   308,
   310,   312,   318,   319,   321,   324,   326,   328,   330,   332,
   334,   336,   338,   340,   344,   346,   350,   354,   356,   360,
   362,   364,   366,   370,   372,   376,   378,   380,   385,   387,
   392,   395
};

static const short yyrhs[] = {    39,
     0,    40,     0,    39,    40,     0,    43,     0,    44,     0,
    42,     0,    45,     0,    46,     0,    48,     0,    65,     0,
    71,     0,    41,     0,    28,    15,    14,     0,    28,    19,
     0,     5,    29,    95,    73,    30,     0,     4,    29,    14,
    76,    30,     0,     3,    29,    47,    81,    30,     0,     9,
    29,    90,    30,     0,     9,    29,    77,    30,     0,    10,
    29,    90,    30,     0,    14,     0,    47,    14,     0,    49,
    72,     0,    49,    31,     0,    50,     0,    51,     0,    54,
     0,    55,     0,    56,     0,    57,     0,    58,     0,    22,
    32,    33,    52,    53,    31,     0,    19,     0,    52,    34,
    19,     0,     0,    34,     0,    23,   100,    32,    35,    15,
    36,    13,    33,    64,    31,     0,     6,   100,    32,    35,
    15,    36,    13,    33,    64,    31,     0,    21,    59,     0,
    22,    60,     0,    23,    96,     0,    23,   100,    32,    96,
     0,    62,     0,    59,    34,    62,     0,    61,     0,    60,
    34,    61,     0,    96,     0,    96,    32,    19,     0,    96,
     0,    96,    32,    85,     0,    22,     0,    21,     0,    23,
     0,    19,     0,    63,     0,    64,    34,    63,     0,     0,
    24,    19,    66,    29,    67,    30,     0,     0,    68,     0,
    69,     0,    68,    37,    69,     0,    63,    70,     0,   100,
     0,    70,    34,   100,     0,    72,     0,    19,     0,    20,
     0,    14,     0,     8,     0,     7,     0,    15,     0,    16,
     0,    11,     0,    25,     0,    18,     0,    17,     0,    36,
     0,    35,     0,    29,     0,    30,     0,    33,     0,    31,
     0,    34,     0,    32,     0,    37,     0,    26,     0,     0,
    34,    74,     0,    75,     0,    74,    34,    75,     0,    27,
    78,     0,    83,     0,     0,    34,    77,     0,    78,     0,
    77,    34,    78,     0,    95,    11,    33,    79,    31,     0,
    95,     0,    80,     0,    79,    34,    80,     0,    15,     0,
    15,    12,    15,     0,     0,    34,    82,     0,    83,     0,
    82,    34,    83,     0,    85,     0,     0,    85,     0,    87,
     0,    84,    29,    82,    30,    86,     0,     0,    87,     0,
    87,    88,     0,    88,     0,    89,     0,    95,     0,    14,
     0,    15,     0,    20,     0,    91,     0,    92,     0,    91,
    17,    92,     0,    93,     0,    92,    18,    93,     0,    29,
    90,    30,     0,    94,     0,    95,    16,    85,     0,    96,
     0,    97,     0,   100,     0,   100,    98,    96,     0,    99,
     0,    99,    98,    96,     0,    25,     0,   101,     0,   101,
    35,    85,    36,     0,    19,     0,    19,    35,    85,    36,
     0,     7,    19,     0,     8,    19,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   259,   262,   263,   266,   267,   268,   269,   270,   271,   272,
   273,   274,   277,   295,   301,   449,   536,   581,   620,   658,
   683,   691,   707,   708,   711,   712,   713,   714,   717,   718,
   719,   722,   749,   757,   772,   773,   777,   796,   813,   869,
   916,   947,   983,   984,   995,   996,  1007,  1015,  1030,  1038,
  1049,  1050,  1051,  1052,  1055,  1063,  1079,  1096,  1132,  1134,
  1137,  1138,  1149,  1161,  1169,  1184,  1185,  1186,  1187,  1188,
  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,  1197,  1198,
  1199,  1200,  1201,  1202,  1203,  1207,  1208,  1211,  1213,  1217,
  1219,  1227,  1235,  1246,  1248,  1252,  1259,  1270,  1335,  1388,
  1389,  1397,  1405,  1415,  1417,  1422,  1429,  1441,  1444,  1446,
  1449,  1450,  1471,  1473,  1476,  1481,  1484,  1491,  1506,  1507,
  1508,  1511,  1514,  1515,  1530,  1531,  1546,  1552,  1563,  1577,
  1578,  1581,  1582,  1590,  1591,  1599,  1603,  1604,  1614,  1623,
  1637,  1645
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","SPEX_OUTPUT",
"SPEX_INPUT","SPEX_IO","SPEX_CHAN","NOW_STRUCT","PROC_STRUCT","DOMAIN","SPEX",
"IN","DOTS","OF","STRING","NUMBER","OPERAND","LOGIC_OR","LOGIC_AND","OTHER",
"SINGLE_OTHER","TYPE","MTYPE","CHAN","PROCTYPE","STRUCT_MEMB","ARROW","AMPERSAND",
"'#'","'('","')'","'}'","'='","'{'","','","'['","']'","';'","program","lines",
"line","linemarker","spexio","spexinput","spexoutput","domain","spexcmp","strings",
"declaration","declaration_2","id_declaration","mtype_declaration","other_list",
"comma_opt","chan_declaration","spexchan_declaration","data_id_decl","mtype_id_decl",
"chan_id_decl","id_insts","m_id_insts","m_id_inst","id_inst","datatype","datatypelist",
"proc_decl","@1","arg_decl_opt","arg_decl_list","arg_decls","arg_id_list","anything",
"eos","args_ranges_opt","args_ranges","arg_range","ranges_opt","ranges","range",
"num_ranges","num_range","arguments_opt","arguments","argument","expression_opt",
"expression","prom_things_opt","prom_things","prom_thing","prom_other","compare",
"or_cmp","and_cmp","logic_cmp","op_cmp","identifier","std_identifier","norm_identifier",
"struct_ind","norm_ident_ind","std_ident_ind","norm_ident", NULL
};
#endif

static const short yyr1[] = {     0,
    38,    39,    39,    40,    40,    40,    40,    40,    40,    40,
    40,    40,    41,    41,    42,    43,    44,    45,    45,    46,
    47,    47,    48,    48,    49,    49,    49,    49,    50,    50,
    50,    51,    52,    52,    53,    53,    54,    55,    56,    57,
    58,    58,    59,    59,    60,    60,    61,    61,    62,    62,
    63,    63,    63,    63,    64,    64,    66,    65,    67,    67,
    68,    68,    69,    70,    70,    71,    71,    71,    71,    71,
    71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
    71,    71,    71,    71,    71,    72,    72,    73,    73,    74,
    74,    75,    75,    76,    76,    77,    77,    78,    78,    79,
    79,    80,    80,    81,    81,    82,    82,    83,    84,    84,
    85,    85,    86,    86,    87,    87,    88,    88,    89,    89,
    89,    90,    91,    91,    92,    92,    93,    93,    94,    95,
    95,    96,    96,    97,    97,    98,    99,    99,   100,   100,
   101,   101
};

static const short yyr2[] = {     0,
     1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     3,     2,     5,     5,     5,     4,     4,     4,
     1,     2,     2,     2,     1,     1,     1,     1,     1,     1,
     1,     6,     1,     3,     0,     1,    10,    10,     2,     2,
     2,     4,     1,     3,     1,     3,     1,     3,     1,     3,
     1,     1,     1,     1,     1,     3,     0,     6,     0,     1,
     1,     3,     2,     1,     3,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     0,     2,     1,
     3,     2,     1,     0,     2,     1,     3,     5,     1,     1,
     3,     1,     3,     0,     2,     1,     3,     1,     0,     1,
     1,     5,     0,     1,     2,     1,     1,     1,     1,     1,
     1,     1,     1,     3,     1,     3,     3,     1,     3,     1,
     1,     1,     3,     1,     3,     1,     1,     4,     1,     4,
     2,     2
};

static const short yydefact[] = {     0,
     0,     0,     0,     0,    71,    70,     0,     0,    74,    69,
    72,    73,    77,    76,    67,    68,     0,     0,     0,     0,
    75,    87,     0,    80,    81,    83,    85,    82,    84,    79,
    78,    86,     1,     2,    12,     6,     4,     5,     7,     8,
     9,     0,    25,    26,    27,    28,    29,    30,    31,    10,
    11,    66,     0,     0,     0,   139,     0,     0,     0,    39,
    43,    49,   132,     0,    40,    45,    47,    41,   132,    57,
     0,    14,     3,    24,    23,    21,   104,    94,     0,     0,
    88,   130,   131,   134,   137,   109,     0,     0,     0,    96,
     0,   122,   123,   125,   128,    99,     0,     0,     0,   109,
   136,     0,     0,     0,     0,     0,     0,    13,    22,   109,
     0,     0,     0,   141,   142,   109,     0,     0,   109,   119,
   120,   121,     0,   110,   111,   116,   117,   118,     0,     0,
    19,     0,    18,     0,     0,     0,   109,    20,    44,    50,
   133,    33,    35,    46,    48,     0,    42,    59,   105,   106,
   108,    17,    95,    99,    16,     0,    89,    90,    93,    15,
   135,   110,   109,   140,   115,     0,   127,    97,   124,   126,
     0,   129,    36,     0,     0,    54,    52,    51,    53,     0,
     0,    60,    61,   109,    92,   109,   138,     0,     0,   102,
     0,   100,    34,    32,     0,    63,    64,    58,     0,   107,
    91,   113,     0,     0,    98,     0,     0,     0,    62,   112,
   114,     0,   103,   101,     0,    65,    55,     0,     0,    38,
     0,    37,    56,     0,     0,     0
};

static const short yydefgoto[] = {   224,
    33,    34,    35,    36,    37,    38,    39,    40,    77,    41,
    42,    43,    44,   143,   174,    45,    46,    47,    48,    49,
    60,    65,    66,    61,   180,   218,    50,   107,   181,   182,
   183,   196,    51,    52,   117,   157,   158,   113,    89,    90,
   191,   192,   111,   149,   150,   123,   151,   210,   125,   126,
   127,    91,    92,    93,    94,    95,   128,    82,    83,   102,
    84,    63,    85
};

static const short yypact[] = {   105,
    -2,     4,    11,    40,-32768,-32768,    53,    54,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    40,    -1,    40,    65,
-32768,-32768,    49,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   105,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    24,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    12,    71,    38,    51,    55,     9,     9,    56,
-32768,    60,    69,    63,    64,-32768,    67,-32768,    -3,-32768,
    83,-32768,-32768,-32768,-32768,-32768,     7,    66,    82,    84,
    70,-32768,-32768,    69,    97,    29,   108,     9,    39,-32768,
    75,    89,    99,-32768,-32768,    36,    88,   128,    40,    29,
-32768,    40,   126,    40,   127,    -5,   118,-32768,-32768,    29,
   119,    38,   120,-32768,-32768,     5,   121,    40,    29,-32768,
-32768,-32768,   123,   112,    29,-32768,-32768,-32768,   138,   124,
-32768,    38,-32768,     9,     9,   122,    29,-32768,-32768,   129,
-32768,-32768,   125,-32768,-32768,   141,-32768,    44,   130,-32768,
   129,-32768,   131,   146,-32768,    38,   132,-32768,-32768,-32768,
-32768,   133,    29,-32768,-32768,   134,-32768,-32768,    99,-32768,
   145,   129,   142,   136,   135,-32768,-32768,-32768,-32768,    40,
   143,   137,-32768,    29,-32768,     5,-32768,    41,   149,   151,
    20,-32768,-32768,-32768,   155,   144,-32768,-32768,    44,-32768,
-32768,    29,   139,   160,-32768,   145,   147,    40,-32768,-32768,
    29,    44,-32768,-32768,    44,-32768,-32768,    43,    45,-32768,
    44,-32768,-32768,   177,   179,-32768
};

static const short yypgoto[] = {-32768,
-32768,   148,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    78,    85,  -159,   -32,-32768,-32768,-32768,-32768,
   -14,-32768,-32768,   150,-32768,-32768,     0,-32768,    76,  -121,
-32768,   -19,-32768,    26,  -114,-32768,   -77,-32768,   -12,  -122,
-32768,   -49,-32768,    57,    58,-32768,   -54,   -11,-32768,   110,
-32768,    -4,-32768
};


#define	YYLAST		204


static const short yytable[] = {    57,
    81,   159,   165,    96,    98,    62,    67,    68,   124,    97,
   168,    79,    80,    56,    69,    79,    80,    56,   120,   121,
   109,   101,   140,    56,   122,    76,    53,    56,   106,   146,
    64,   156,    54,    98,   185,    79,    80,    88,   130,    55,
   110,   162,   120,   121,    79,    80,   136,    56,   122,    22,
   205,   137,   217,   206,    74,   217,    56,   154,    56,   172,
    32,   223,   176,    71,   177,   178,   179,    72,   131,   200,
   202,   159,   132,   220,   184,   222,   221,   154,   221,    98,
    98,    58,    59,    70,    78,    86,    87,    62,   165,    99,
   141,   100,    67,   101,   147,   103,   108,   104,   105,   112,
   114,   154,   115,   116,   133,   134,   161,     1,     2,     3,
     4,     5,     6,     7,     8,     9,   135,   138,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,   119,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,   129,   137,   142,   145,   148,   164,   152,   155,
   160,   163,   166,   167,   171,   175,   136,  -110,   173,   190,
   193,   203,   204,   184,   132,   186,   194,   207,   187,   189,
   195,   212,   198,   199,   213,   197,   225,   208,   226,   215,
    73,   144,   219,   139,   209,   201,   214,   153,   188,   211,
   169,    75,   170,   118,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   216
};

static const short yycheck[] = {     4,
    55,   116,   125,    58,    59,    17,    18,    19,    86,    59,
   132,     7,     8,    19,    19,     7,     8,    19,    14,    15,
    14,    25,   100,    19,    20,    14,    29,    19,    32,    35,
    32,    27,    29,    88,   156,     7,     8,    29,    88,    29,
    34,   119,    14,    15,     7,     8,    11,    19,    20,    26,
    31,    16,   212,    34,    31,   215,    19,   112,    19,   137,
    37,   221,    19,    15,    21,    22,    23,    19,    30,   184,
    30,   186,    34,    31,    34,    31,    34,   132,    34,   134,
   135,    29,    29,    19,    14,    35,    32,    99,   211,    34,
   102,    32,   104,    25,   106,    33,    14,    34,    32,    34,
    19,   156,    19,    34,    30,    17,   118,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    18,    30,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    35,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    35,    16,    19,    19,    29,    36,    30,    30,
    30,    29,    15,    30,    33,    15,    11,    29,    34,    15,
    19,    13,    12,    34,    34,    34,    31,    13,    36,    36,
    36,    33,    30,    37,    15,   180,     0,    34,     0,    33,
    33,   104,   215,    99,   199,   186,   206,   112,   163,   202,
   134,    42,   135,    84,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   208
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/Gnu/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/Gnu/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 11:
#line 273 "spexgram.y"
{ printf("%s", yyvsp[0].str); ;
    break;}
case 13:
#line 278 "spexgram.y"
{
			char *tmp_file;
			int len;
	
			tmp_file = strdup(yyvsp[0].str + 1);
			len = strlen(tmp_file);
			tmp_file[len-1] = '\0';
			
			if (file_name)
				free(file_name);
		  	file_name = tmp_file;
		  	lineno = atoi(yyvsp[-1].str) - 1; /* number is for the next line */
		  	
		  	printf("# %s %s", yyvsp[-1].str, yyvsp[0].str);
		  	
		  	yyval.str = NULL;
		  ;
    break;}
case 14:
#line 296 "spexgram.y"
{
		  	printf("# %s", yyvsp[0].str);
		  ;
    break;}
case 15:
#line 306 "spexgram.y"
{
		  	struct largrange *cur_lr;
		  	struct range *cur_range;
		  	struct lrangepart *cur_lrp;
		  	struct stringlist *types;
		  	struct stringlist *cur_t;
		  	
		  	// TODO: make sure %% works all right
		  	// TODO: stricter type checking
		  	// TODO: make sure argument passing works
		  	//             (should we add casts?)
		  	// TODO: better way to deal with mtypes (add enums in C?)
		  	
		  	// based on:
		  	
		  	// spex_input(string, id1 in range1, id2 in range2, ...);
		  	// ->
		  	// #if SPEX
		  	// c_code {
		  	// spex__inputs(string,
		  	//		"id1", &id1, "range1",
		  	//		"id2", &id2, "range2",
		  	// 		...
		  	// ); };
		  	// #else
		  	// c_code {
		  	//	id1 = newDomain("range1");
		  	//	id2 = newDomain("range2");
		  	//	...
		  	// };
		  	// #endif
		  	
		  	// TODO Should check the string for amount and type of %?'s
		  	
		  	types = findchantypes(yyvsp[-2].id->name);
		  	if (types == NULL) {
				fprintf(stderr, "%s:%d: error: no types defined for channel: %s\n", file_name, lineno, yyvsp[-2].id->name);
				fatalerr = 1;
				return NULL;
			}
		  	
		  	printf("\n#ifdef SPEX /*spexio*/\n");
		  	printf("c_code {\n\t");
		  	printf("spex__io(");
		  	printf("\"");
		  	printf("%s", yyvsp[-2].id->name);
		  	for (cur_lr = yyvsp[-1].arl, cur_t = types; cur_lr != NULL && cur_t != NULL; cur_lr = cur_lr->next, cur_t = cur_t->next) {
			  	printf(" ! %%");
			  	if (cur_lr->t == t_range)
				  	printf("&");
				if (strcmp(cur_t->label, "int") == 0)
				  	printf("d");
				else if (strcmp(cur_t->label, "short") == 0)
				  	printf("h");
				else if (strcmp(cur_t->label, "mtype") == 0)
				  	printf("e");
				else if (strcmp(cur_t->label, "char") == 0)
				  	printf("c");
				else {
					fprintf(stderr, "%s:%d: error: unknown type of channel %s: %s\n", file_name, lineno, yyvsp[-2].id->name, cur_t->label);
					fatalerr = 1;
				  	printf("X");
				}
			}
		  	printf("\"");
		  	if (cur_lr == NULL && cur_t != NULL) {
				fprintf(stderr, "%s:%d: error: too few parameters for spexio on: %s\n", file_name, lineno, yyvsp[-2].id->name);
				fatalerr = 1;
		  	} else  if (cur_lr != NULL && cur_t == NULL) {
				fprintf(stderr, "%s:%d: error: too many parameters for spexio on: %s\n", file_name, lineno, yyvsp[-2].id->name);
				fatalerr = 1;
			}

		  	for (cur_lr = yyvsp[-1].arl; cur_lr != NULL; cur_lr = cur_lr->next) {
			  	printf(",\n\t\t");
		  		if (cur_lr->t == t_range) {
			  		cur_range = cur_lr->u.ra;
			  		printf("\"");
			  		print_ident(cur_range->id, 0);
			  		printf("\", ");
			  		printf("&");
			  		print_ident(cur_range->id, 1);
			  		printf(", \"");
			  		for (cur_lrp = cur_range->parts; cur_lrp != NULL; cur_lrp = cur_lrp->next) {
			  			if (cur_lrp->lb == cur_lrp->ub) {
			  				printf("%s, ", cur_lrp->lb);
			  			} else {
			  				printf("%s..%s, ", cur_lrp->lb, cur_lrp->ub);
			  			}
			  		}
			  		printf("\"");
		  		} else {
			  		print_expr(cur_lr->u.parts, 1);	
		  		}
			  	if (cur_lr->next == NULL) {
			  		printf("\n\t");
			  	}
		  	}
		  	printf(");\n");
		  	printf("}\n");
		  	
		  	printf("#else\n");
		  	
		  	// If no assignments have to be made, insert a 'skip' command.
		  	if( yyvsp[-1].arl == NULL ) {
		  		printf("skip\n");
		  	} else {
			  	printf("c_code {\n");
			  	
			  	for (cur_lr = yyvsp[-1].arl; cur_lr != NULL; cur_lr = cur_lr->next) {
			  		if (cur_lr->t == t_range && cur_lr->u.ra != NULL) {
				  		cur_range = cur_lr->u.ra;
				  		printf("\t");
				  		print_ident(cur_range->id, 1);
				  		printf(" = newDomain(\"");
				  		for (cur_lrp = cur_range->parts; cur_lrp != NULL; cur_lrp = cur_lrp->next) {
				  			if (cur_lrp->lb == cur_lrp->ub) {
				  				printf("%s, ", cur_lrp->lb);
				  			} else {
				  				printf("%s..%s, ", cur_lrp->lb, cur_lrp->ub);
				  			}
				  		}
				  		printf("\");\n");
				  	}
			  	}
			  	
			  	printf("}\n");
			  	
			  	//printf("printf(%s \"\\n\"", $3); /* String concatination like this doesn't work in Spin */
			  	printf("printf(%s ", yyvsp[-2].id->name);
			  	for ( cur_lr = yyvsp[-1].arl; cur_lr != NULL; cur_lr = cur_lr->next) {
			  		if (cur_lr->t == t_arg && cur_lr->u.parts != NULL) {
			  			printf(", ");	
			  			print_expr(cur_lr->u.parts, 0);
			  		}
			  	}
			  	printf(");\n");
			}
		  	printf("#endif\n");
		  	
		  ;
    break;}
case 16:
#line 454 "spexgram.y"
{
		  	struct lrange *cur_lr;
		  	struct range *cur_range;
		  	struct lrangepart *cur_lrp;
		  	
		  	// spex_input(string, id1 in range1, id2 in range2, ...);
		  	// ->
		  	// #if SPEX
		  	// c_code {
		  	// spex__inputs(string,
		  	//		"id1", &id1, "range1",
		  	//		"id2", &id2, "range2",
		  	// 		...
		  	// ); };
		  	// #else
		  	// c_code {
		  	//	id1 = newDomain("range1");
		  	//	id2 = newDomain("range2");
		  	//	...
		  	// };
		  	// #endif
		  	
		  	// TODO Should check the string for amount and type of %?'s
		  	
		  	printf("\n#ifdef SPEX /*spexinput*/\n");
		  	printf("c_code {\n\t");
		  	printf("spex__inputs(%s", yyvsp[-2].str);

		  	for (cur_lr = yyvsp[-1].rl; cur_lr != NULL && cur_lr->ra != NULL; cur_lr = cur_lr->next) {
		  		cur_range = cur_lr->ra;
		  		printf(",\n\t\t");
		  		printf("\"");
		  		print_ident(cur_range->id, 0);
		  		printf("\", ");
		  		printf("&");
		  		print_ident(cur_range->id, 1);
		  		printf(", \"");
		  		for (cur_lrp = cur_range->parts; cur_lrp != NULL; cur_lrp = cur_lrp->next) {
		  			if (cur_lrp->lb == cur_lrp->ub) {
		  				printf("%s, ", cur_lrp->lb);
		  			} else {
		  				printf("%s..%s, ", cur_lrp->lb, cur_lrp->ub);
		  			}
		  		}
		  		printf("\"");
		  		if (cur_lr->next == NULL) {
		  			printf("\n\t");
		  		}
		  	}
		  	printf(");\n");
		  	printf("}\n");
		  	
		  	printf("#else\n");
		  	
		  	// If no assignments have to be made, insert a 'skip' command.
		  	if( yyvsp[-1].rl == NULL ) {
		  		printf("skip\n");
		  	} else {
			  	printf("c_code {\n");
			  	
			  	for (cur_lr = yyvsp[-1].rl; cur_lr != NULL && cur_lr->ra != NULL; cur_lr = cur_lr->next) {
			  		cur_range = cur_lr->ra;
			  		printf("\t");
			  		print_ident(cur_range->id, 1);
			  		printf(" = newDomain(\"");
			  		for (cur_lrp = cur_range->parts; cur_lrp != NULL; cur_lrp = cur_lrp->next) {
			  			if (cur_lrp->lb == cur_lrp->ub) {
			  				printf("%s, ", cur_lrp->lb);
			  			} else {
			  				printf("%s..%s, ", cur_lrp->lb, cur_lrp->ub);
			  			}
			  		}
			  		printf("\");\n");
			  	}
			  	
			  	printf("}\n");
			}
		  	printf("#endif\n");
		  	
		  ;
    break;}
case 17:
#line 541 "spexgram.y"
{
		  	struct largs *cur_arg;
		  	struct stringlist *cur_sl;
		  	
		  	//#if SPEX
		  	// c_code { spex__output(string, expr1, expr2, ...); };
		  	//#else
		  	// printf(string, expr1, expr2, ...);
		  	//#endif
		  	
		  	// TODO Should change %c and %h to %d in printf string.
		  	
		  	printf("\n#ifdef SPEX /*spexoutput*/\n");
		  	printf("c_code { spex__outputs(");
		  	
		  	for ( cur_sl = yyvsp[-2].sl; cur_sl != NULL ; cur_sl = cur_sl->next ) {
		  		printf(" %s", cur_sl->label);
		  	}
		  	
		  	for ( cur_arg = yyvsp[-1].al; cur_arg != NULL; cur_arg = cur_arg->next) {
		  		printf(", ");
		  		print_expr(cur_arg->parts, 1);	
		  	}
		  	printf("); }\n#else\n");
		  	//printf("printf(%s \"\\n\"", $3); /* String concatination like this doesn't work in Spin */
		  	printf("printf(");
		  	for ( cur_sl = yyvsp[-2].sl; cur_sl != NULL ; cur_sl = cur_sl->next ) {
		  		printf(" %s", cur_sl->label);
		  	}
		  	for ( cur_arg = yyvsp[-1].al; cur_arg != NULL; cur_arg = cur_arg->next) {
		  		printf(", ");	
		  		print_expr(cur_arg->parts, 0);	
		  	}
		  	printf(");\n#endif\n");

		  	
		  ;
    break;}
case 18:
#line 585 "spexgram.y"
{ 
		  	struct compare *cmp;
		  	
		  	cmp = yyvsp[-1].cmpe->cmp;

			// 'DOMAIN( id __ expr );'
			// ->
		  	// 'atomic { c_expr { DHas__(id, (expr)) } -> c_code { id = Domain__(id, (expr)); }; };'

//		  	printf("atomic { c_expr { %s(", dhas_op(cmp->op));
//		  	print_ident(cmp->id, 1);
//		  	printf(", (");
//
//		  	print_expr(cmp->expr, 1);				
//		  	printf(")) } -> ");
//		  	
//		  						
//			printf("c_code {");
//			print_ident(cmp->id, 1);
//			printf(" = %s(", domain_op(cmp->op));
//			print_ident(cmp->id, 1);
//			printf(", (");
//
//			print_expr(cmp->expr, 1);
//		  	printf(")); }; }");

//			print_cmpe($3, 1);

			printf("atomic { ");
			print_cmpe_cond(yyvsp[-1].cmpe, 1);
			printf(" ->\n\t");
			print_cmpe_eff(yyvsp[-1].cmpe, 1);
			printf("; }");
		  	
		  ;
    break;}
case 19:
#line 624 "spexgram.y"
{ 
		  	struct lrange *cur_lr;
		  	struct range *cur_range;
		  	struct lrangepart *cur_lrp;
		  	
		  	// DOMAIN( id1 in {range1}, id2 in {range2}, ...)
		  	// ->
		  	// c_code {
		  	// id1 = newDomain(range1);
		  	// id2 = newDomain(range2);
		  	// ...
		  	// };
		  	
		  	printf("\nc_code{\n");
		  	
		  	for (cur_lr = yyvsp[-1].rl; cur_lr != NULL && cur_lr->ra != NULL; cur_lr = cur_lr->next) {
		  		cur_range = cur_lr->ra;
		  		printf("\t");
		  		print_ident(cur_range->id, 1);
		  		printf(" = newDomain(\"");
		  		for (cur_lrp = cur_range->parts; cur_lrp != NULL; cur_lrp = cur_lrp->next) {
		  			if (cur_lrp->lb == cur_lrp->ub) {
		  				printf("%s, ", cur_lrp->lb);
		  			} else {
		  				printf("%s..%s, ", cur_lrp->lb, cur_lrp->ub);
		  			}
		  		}
		  		printf("\");\n");
		  	}
		  	printf("}\n");
		  	
		  ;
    break;}
case 20:
#line 662 "spexgram.y"
{
		  	//#if SPEX
		  	// (id __ (expr));
		  	//#else
		  	//atomic { c_expr { DHas__(id, (expr)) } -> c_code { id = D__(id, (expr)); }; };
		  	//#endif


		  	printf("\n#ifdef SPEX /*spexcmp*/\n(");
		  	print_cmpe(yyvsp[-1].cmpe);
		  	printf(")\n#else\n");

			printf("atomic { ");
			print_cmpe_cond(yyvsp[-1].cmpe, 1);
			printf(" ->\n\t");
			print_cmpe_eff(yyvsp[-1].cmpe, 1);
			printf("; }");
		  	printf("\n#endif\n");
		  ;
    break;}
case 21:
#line 684 "spexgram.y"
{
		  	struct stringlist *newol;
		  	newol = calloc(1, sizeof(struct stringlist));
		  	newol->label = yyvsp[0].str;
		  	
		  	yyval.sl = newol;
		  ;
    break;}
case 22:
#line 692 "spexgram.y"
{
		  	struct stringlist *newol, *endol;
		  	newol = calloc(1, sizeof(struct stringlist));
		  	newol->label = yyvsp[0].str;
		  	
		  	for ( endol = yyvsp[-1].sl; endol->next != NULL; endol = endol->next) {
		  		;
		  	}
		  	endol->next = newol;
		  	
		  	yyval.sl = yyvsp[-1].sl;
		  ;
    break;}
case 23:
#line 707 "spexgram.y"
{ printf(";"); ;
    break;}
case 24:
#line 708 "spexgram.y"
{ printf("\n}"); ;
    break;}
case 25:
#line 711 "spexgram.y"
{ yyval.str = NULL; ;
    break;}
case 26:
#line 712 "spexgram.y"
{ yyval.str = NULL; ;
    break;}
case 27:
#line 713 "spexgram.y"
{ yyval.str = NULL; ;
    break;}
case 28:
#line 714 "spexgram.y"
{ yyval.str = NULL; ;
    break;}
case 32:
#line 724 "spexgram.y"
{
		  	struct mtypelist *ol;
		  	int nmtypes = 0;
		  	int i;
		  	char buf[15];
		  	
		  	mtypes = yyvsp[-2].ml;
		  	printf("%s = { ", yyvsp[-5].str);
		  	for ( ol = yyvsp[-2].ml; ol != NULL; ol = ol->next ) {
		  		printf("%s", ol->label);
		  		if ( ol->next != NULL ) {
		  			printf(", ");
		  		}
		  		nmtypes++;
		  	}
		  	printf(" }");
		  	i = nmtypes;
		  	for ( ol = yyvsp[-2].ml; ol != NULL; ol = ol->next ) {
		  		sprintf(buf, "%d", i);
		  		ol->intrepr = strdup(buf);
		  		i--;
		  	}
		  ;
    break;}
case 33:
#line 750 "spexgram.y"
{
		  	struct mtypelist *newol;
		  	newol = calloc(1, sizeof(struct mtypelist));
		  	newol->label = yyvsp[0].str;
		  	
		  	yyval.ml = newol;
		  ;
    break;}
case 34:
#line 758 "spexgram.y"
{
		  	struct mtypelist *newol, *endol;
		  	newol = calloc(1, sizeof(struct mtypelist));
		  	newol->label = yyvsp[0].str;
		  	
		  	for ( endol = yyvsp[-2].ml; endol->next != NULL; endol = endol->next) {
		  		;
		  	}
		  	endol->next = newol;
		  	
		  	yyval.ml = yyvsp[-2].ml;
		  ;
    break;}
case 37:
#line 779 "spexgram.y"
{
		  	struct stringlist *curs;
		  	
		  	printf("chan ");
		  	print_ident(yyvsp[-8].id, 0);
		  	printf(" = [%s] of {", yyvsp[-5].str);
		  	
		  	for (curs = yyvsp[-1].sl; curs != NULL; curs = curs->next) {
		  		printf(" %s", curs->label);
		  		if ( curs->next != NULL) {
		  			printf(",");
		  		}
		  	}
		  	printf(" }");
		  ;
    break;}
case 38:
#line 798 "spexgram.y"
{
		  	struct chandecllist *newcl;
		  	newcl = calloc(1, sizeof(struct chandecllist));
		  	newcl->chan = yyvsp[-8].id->name;
		  	newcl->types = yyvsp[-1].sl;
		  	newcl->next = channels;
		  	channels = newcl;
		  	if (atoi(yyvsp[-5].str) != 0) {
		  		fprintf(stderr, "%s:%d: error: spexchan size must be 0 (not %s) for channel: %s\n", file_name, lineno, yyvsp[-5].str, yyvsp[-8].id->name);
		  		fatalerr = 1;
		  	}
		  		
		  ;
    break;}
case 39:
#line 814 "spexgram.y"
{
		  	struct id_inst *curInst;
	  		IdEntry *newId = NULL;
	  		IdEntry *firstNewId = NULL;
		  	IdEntry *lastNewId = NULL;
		  	
		  	printf("%s ", yyvsp[-1].str);
		  	for (curInst = yyvsp[0].ids; curInst != NULL; curInst = curInst->next) {
		  		
		  		print_ident(curInst->id, 0);
		  		if ( curInst->expart ) {
		  			printf(" = ");
		  			print_expr(curInst->expart, 0);
		  		}
		  		
		  		if (curInst->next != NULL) {
		  			printf(", ");
		  		}
		  		
		  		// Append new IdEntry to local list
		  		newId = (IdEntry *) calloc(1, sizeof(IdEntry));
		  		newId->label = curInst->id->name; // Needs strdup?
		  		newId->type = yyvsp[-1].str;
		  		
		  		if ( firstNewId == NULL ) {
		  			firstNewId = lastNewId = newId;
		  		} else {
		  			lastNewId->next = newId;
		  			lastNewId = newId;
		  		}
		  		
		  	}
		  	//printf(";");

			
		  	// Append local IdEntry list to the appropriate global list
		  	if (proctype_seen) {
		  		if ( localIds == NULL ) {
		  			localIds = curLclId = firstNewId;
		  		} else {
		  			curLclId->next = lastNewId;
		  			curLclId = lastNewId;
		  		}
		  	} else {
		  		if ( glIds == NULL ) {
		  			glIds = curGlId = firstNewId;
		  		} else {
		  			curGlId->next = lastNewId;
		  			curGlId = lastNewId;
		  		}
		  		
		  	}
		  ;
    break;}
case 40:
#line 870 "spexgram.y"
{
		  	struct id_inst *curInst;
	  		IdEntry *newId;

	  		newId = (IdEntry *) calloc(1, sizeof(IdEntry));
	  		newId->label = yyvsp[0].ids->id->name; // Needs strdup?
	  		newId->type = "mtype";
		  	
		  	printf("%s ", yyvsp[-1].str);
		  	for (curInst = yyvsp[0].ids; curInst != NULL; curInst = curInst->next) {
		  		
		  		print_ident(curInst->id, 0);
		  		if ( curInst->expart ) {
		  			printf(" = ");
		  			print_expr(curInst->expart, 0);
		  		}
		  		
		  		if (curInst->next != NULL) {
		  			printf(", ");
		  		}
		  		
		  	}
		  	//printf(";");
		  	
		  	if (proctype_seen) {
		  		if ( localIds == NULL ) {
		  			localIds = curLclId = newId;
		  		} else {
		  			curLclId->next = newId;
		  			curLclId = newId;
		  		}
		  		//printf("/* Local declaration of %s %s */", $1, $2->id->name);
		  	} else {
		  		if ( glIds == NULL ) {
		  			glIds = curGlId = newId;
		  		} else {
		  			curGlId->next = newId;
		  			curGlId = newId;
		  		}
		  		
		  		//printf("/* Global declaration of %s %s */", $1, newId->label);
		  		
		  	}
		  ;
    break;}
case 41:
#line 917 "spexgram.y"
{
	  		IdEntry *newId;

	  		newId = (IdEntry *) calloc(1, sizeof(IdEntry));
	  		newId->label = yyvsp[0].id->name; // Needs strdup?
	  		newId->type = "chan";
		  	
		  	printf("chan ");
		  	print_ident(yyvsp[0].id, 0);
		  	
		  	if (proctype_seen) {
		  		if ( localIds == NULL ) {
		  			localIds = curLclId = newId;
		  		} else {
		  			curLclId->next = newId;
		  			curLclId = newId;
		  		}
		  		//printf("/* Local declaration of %s %s */", $1, $2->id->name);
		  	} else {
		  		if ( glIds == NULL ) {
		  			glIds = curGlId = newId;
		  		} else {
		  			curGlId->next = newId;
		  			curGlId = newId;
		  		}
		  		
		  		//printf("/* Global declaration of %s %s */", $1, newId->label);
		  		
		  	}
		  ;
    break;}
case 42:
#line 948 "spexgram.y"
{
	  		IdEntry *newId;

	  		newId = (IdEntry *) calloc(1, sizeof(IdEntry));
	  		newId->label = yyvsp[-2].id->name; // Needs strdup?
	  		newId->type = "chan";

		  	printf("chan ");
		  	print_ident(yyvsp[-2].id, 0);
		  	printf(" = ");
		  	print_ident(yyvsp[0].id, 0);

		  	if (proctype_seen) {
		  		if ( localIds == NULL ) {
		  			localIds = curLclId = newId;
		  		} else {
		  			curLclId->next = newId;
		  			curLclId = newId;
		  		}
		  		//printf("/* Local declaration of %s %s */", $1, $2->id->name);
		  	} else {
		  		if ( glIds == NULL ) {
		  			glIds = curGlId = newId;
		  		} else {
		  			curGlId->next = newId;
		  			curGlId = newId;
		  		}
		  		
		  		//printf("/* Global declaration of %s %s */", $1, newId->label);
		  		
		  	}
		  ;
    break;}
case 44:
#line 985 "spexgram.y"
{
		  	struct id_inst *endol;
		  	for(endol = yyvsp[-2].ids; endol->next != NULL; endol = endol->next) {
		  		;
		  	}
		  	endol->next = yyvsp[0].ids;
		  	yyval.ids = yyvsp[-2].ids;
		  ;
    break;}
case 46:
#line 997 "spexgram.y"
{
		  	struct id_inst *endol;
		  	for(endol = yyvsp[-2].ids; endol->next != NULL; endol = endol->next) {
		  		;
		  	}
		  	endol->next = yyvsp[0].ids;
		  	yyval.ids = yyvsp[-2].ids;
		  ;
    break;}
case 47:
#line 1008 "spexgram.y"
{
		  	struct id_inst *newid;
		  	newid = calloc(1, sizeof(struct id_inst));
		  	newid->id = yyvsp[0].id;
		  	
		  	yyval.ids = newid;
		  ;
    break;}
case 48:
#line 1016 "spexgram.y"
{
		  	struct id_inst *newid;
			struct exprpart *newpart;		  	
		  	newid = calloc(1, sizeof(struct id_inst));
		  	newid->id = yyvsp[-2].id;
		  	
		  	newpart = calloc(1, sizeof(struct exprpart));
		  	newpart->expr = yyvsp[0].str;
		  	newid->expart = newpart;
		  	
		  	yyval.ids = newid;
		  ;
    break;}
case 49:
#line 1031 "spexgram.y"
{
		  	struct id_inst *newid;
		  	newid = calloc(1, sizeof(struct id_inst));
		  	newid->id = yyvsp[0].id;
		  	
		  	yyval.ids = newid;
		  ;
    break;}
case 50:
#line 1039 "spexgram.y"
{
		  	struct id_inst *newid;
		  	newid = calloc(1, sizeof(struct id_inst));
		  	newid->id = yyvsp[-2].id;
		  	newid->expart = yyvsp[0].ep;
		  	
		  	yyval.ids = newid;
		  ;
    break;}
case 55:
#line 1056 "spexgram.y"
{
		  	struct stringlist *newsl;
		  	newsl = calloc(1, sizeof(struct stringlist));
		  	newsl->label = yyvsp[0].str;
		  	
		  	yyval.sl = newsl;
		  ;
    break;}
case 56:
#line 1064 "spexgram.y"
{
		  	struct stringlist *newsl, *endsl;
		  	newsl = calloc(1, sizeof(struct stringlist));
		  	newsl->label = yyvsp[0].str;
		  	
		  	for ( endsl = yyvsp[-2].sl; endsl->next != NULL; endsl = endsl->next) {
		  		;
		  	}
		  	endsl->next = newsl;
		  	
		  	yyval.sl = yyvsp[-2].sl;
		  ;
    break;}
case 57:
#line 1081 "spexgram.y"
{
		  	IdEntry *tmpId, *nextId;
		  	
		  	printf("%s %s", yyvsp[-1].str, yyvsp[0].str);

		  	last_proctype = strdup(yyvsp[0].str);
		  	proctype_seen = 1;
		  	
		  	for ( tmpId = localIds; tmpId != NULL; tmpId = nextId ) {
		  		nextId = tmpId->next;
		  		free(tmpId);
		  	}
		  	localIds = curLclId = NULL;
		  ;
    break;}
case 58:
#line 1098 "spexgram.y"
{
		  	struct arg_list *cur_als;
		  	struct id_inst *cur_ids;
		  	
		  	
		  	printf("( ");
		  	for ( cur_als = yyvsp[-1].args; cur_als != NULL; cur_als = cur_als->next ) {
		  		printf("%s ", cur_als->type);
		  		for ( cur_ids = cur_als->id_list; cur_ids != NULL; cur_ids = cur_ids->next ) {
		  			IdEntry *newId;

		  			newId = (IdEntry *) calloc(1, sizeof(IdEntry));
		  			newId->label=cur_ids->id->name;
		  			newId->type = cur_als->type;
			  		if ( localIds == NULL ) {
			  			localIds = curLclId = newId;
			  		} else {
			  			curLclId->next = newId;
			  			curLclId = newId;
			  		}
		  			
		  			print_ident(cur_ids->id, 0);
		  			if (cur_ids->next != NULL) {
		  				printf(", ");
		  			}
		  		}
		  		if ( cur_als->next != NULL ) {
		  			printf("; ");
		  		}
		  	}
		  	printf(" ) ");
		  ;
    break;}
case 59:
#line 1133 "spexgram.y"
{ yyval.args = NULL; ;
    break;}
case 62:
#line 1139 "spexgram.y"
{
		  	struct arg_list *end_als;
		  	for(end_als = yyvsp[-2].args; end_als->next != NULL; end_als = end_als->next) {
		  		;
		  	}
		  	end_als->next = yyvsp[0].args;
		  	yyval.args = yyvsp[-2].args;
		  ;
    break;}
case 63:
#line 1150 "spexgram.y"
{
		  	struct arg_list *als;
		  	als = calloc(1, sizeof(struct arg_list));
		  	
		  	als->type = yyvsp[-1].str;
		  	als->id_list = yyvsp[0].ids;
		  	
		  	yyval.args = als;
		  ;
    break;}
case 64:
#line 1162 "spexgram.y"
{
		  	struct id_inst *newid;
		  	newid = calloc(1, sizeof(struct id_inst));
		  	newid->id = yyvsp[0].id;
		  	
		  	yyval.ids = newid;
		  ;
    break;}
case 65:
#line 1170 "spexgram.y"
{
		  	struct id_inst *endid;
		  	struct id_inst *newid;
		  	newid = calloc(1, sizeof(struct id_inst));
		  	newid->id = yyvsp[0].id;

		  	for(endid = yyvsp[-2].ids; endid->next != NULL; endid = endid->next) {
		  		;
		  	}
		  	endid->next = newid;
		  	yyval.ids = yyvsp[-2].ids;
		  ;
    break;}
case 78:
#line 1196 "spexgram.y"
{ yyval.str = "]"; ;
    break;}
case 79:
#line 1197 "spexgram.y"
{ yyval.str = "["; ;
    break;}
case 80:
#line 1198 "spexgram.y"
{ yyval.str = "("; ;
    break;}
case 81:
#line 1199 "spexgram.y"
{ yyval.str = ")"; ;
    break;}
case 82:
#line 1200 "spexgram.y"
{ yyval.str = "{"; ;
    break;}
case 83:
#line 1201 "spexgram.y"
{ yyval.str = "}"; ;
    break;}
case 84:
#line 1202 "spexgram.y"
{ yyval.str = ","; ;
    break;}
case 85:
#line 1203 "spexgram.y"
{ yyval.str = "="; ;
    break;}
case 86:
#line 1207 "spexgram.y"
{ yyval.str = ";"; ;
    break;}
case 88:
#line 1212 "spexgram.y"
{ yyval.arl = NULL; ;
    break;}
case 89:
#line 1214 "spexgram.y"
{ yyval.arl = yyvsp[0].arl; ;
    break;}
case 90:
#line 1218 "spexgram.y"
{ yyval.arl = yyvsp[0].arl; ;
    break;}
case 91:
#line 1222 "spexgram.y"
{
			yyval.arl = largrange_append(yyvsp[-2].arl, yyvsp[0].arl);
		  ;
    break;}
case 92:
#line 1228 "spexgram.y"
{ 
	          	struct largrange *rp;
	          	rp = calloc(1, sizeof(struct largrange));
	          	rp->u.ra = yyvsp[0].r;
	          	rp->t = t_range;
	          	yyval.arl = rp;
	          ;
    break;}
case 93:
#line 1236 "spexgram.y"
{
			struct largrange *arg;
			arg = calloc(1, sizeof(struct largrange));
			arg->u.parts = yyvsp[0].ep;
	          	arg->t = t_arg;
		  	yyval.arl = arg;
		  ;
    break;}
case 94:
#line 1247 "spexgram.y"
{ yyval.rl = NULL; ;
    break;}
case 95:
#line 1249 "spexgram.y"
{ yyval.rl = yyvsp[0].rl; ;
    break;}
case 96:
#line 1253 "spexgram.y"
{ 
	          	struct lrange *rp;
	          	rp = calloc(1, sizeof(struct lrange));
	          	rp->ra = yyvsp[0].r;
	          	yyval.rl = rp;
	          ;
    break;}
case 97:
#line 1262 "spexgram.y"
{
	          	struct lrange *rp;
	          	rp = calloc(1, sizeof(struct lrange));
	          	rp->ra = yyvsp[0].r;
		  	yyval.rl = lrange_append(yyvsp[-2].rl, rp);
		  ;
    break;}
case 98:
#line 1275 "spexgram.y"
{
		  	struct range *r;
		  	struct lrangepart *lrp = NULL;
			IdEntry *tmpId;
			char invalidRange = 0;
			
			int lb, ub;
			char *lbs, *ubs;

		  	tmpId = findId(yyvsp[-4].id->name);
		  	
		  	if ( tmpId != NULL ) {
		  		if ( (strcmp(tmpId->type, "bit")) == 0 ) {
		  			lb  =  0; 	ub  =  1;
		  			lbs = "0"; 	ubs = "1";
		  		} else if ( (strcmp(tmpId->type, "bool")) == 0 ) {
		  			lb  =  0; 	ub  =  1;
		  			lbs = "0"; 	ubs = "1";
		  		} else if ( (strcmp(tmpId->type, "byte")) == 0 ) {
		  			lb  =  0; 	ub  =  255;
		  			lbs = "0"; 	ubs = "255";
		  		} else if ( (strcmp(tmpId->type, "mtype")) == 0 ) {
		  			lb  =  1; 	ub  =  255;
		  			lbs = "1"; 	ubs = "255";
		  		} else if ( (strcmp(tmpId->type, "chan")) == 0 ) {
		  			lb  =  0; 	ub  =  255;
		  			lbs = "0"; 	ubs = "255";
		  		} else if ( (strcmp(tmpId->type, "short")) == 0 ) {
		  			lb = -32767;	lbs = "-32767";
		  			ub =  32767;	ubs =  "32767";
		  		} else if ( (strcmp(tmpId->type, "int")) == 0 ) {
		  			lb  =  -2147483647;	ub  =  2147483647;
		  			lbs = "-2147483647";	ubs = "2147483647";
		  		} else {
		  			// Unknown type might be an int, so allow the int range.
		  			lb = -2147483647;
		  			ub =  2147483647;
		  			// But if it's invalid, we will select the default range of 0..255
		  			lbs = "0";
		  			ubs = "255";
		  		}
		  		
		  		if ( ! isRangeBetween(yyvsp[-1].rp, lb, ub) ) {
		  			lrp = calloc(1, sizeof(struct lrangepart));
		  			lrp->lb = strdup(lbs);
		  			lrp->ub = strdup(ubs);
		  			invalidRange = 1;
		  		} 
	  		}

			if ( invalidRange ) {
				fprintf(stderr, "%s:%d: warning: invalid range specified for: %s\n", file_name, lineno, yyvsp[-4].id->name);
				fprintf(stderr, "%s:%d: using default range instead: (%s..%s)\n", file_name, lineno, lrp->lb, lrp->ub);
			}
			
		  	r = calloc(1, sizeof(struct range));
		  	r->id = yyvsp[-4].id;
		  	r->parts = invalidRange ? lrp: yyvsp[-1].rp;
		  	yyval.r = r;
		  ;
    break;}
case 99:
#line 1336 "spexgram.y"
{
		  	struct range *r;
		  	struct lrangepart *lrp;
			
			IdEntry *tmpId;

		  	r = calloc(1, sizeof(struct range));
		  	r->id = yyvsp[0].id;

		  	lrp = calloc(1, sizeof(struct lrangepart));
		  	
		  	// Check to see if the identifier has been defined
		  	// in either global or local context.
		  	// If it is, create the lower- and upperbound depending
		  	// on the type of it.
		  	
		  	tmpId = findId(yyvsp[0].id->name);
		  	
		  	if (tmpId == NULL ) {
			  	lrp->lb = strdup("0");
			  	lrp->ub = strdup("255");
		  	} else {
		  		if ( (strcmp(tmpId->type, "bit")) == 0 ) {
				  	lrp->lb = strdup("0");
				  	lrp->ub = strdup("1");
		  		} else if ( (strcmp(tmpId->type, "bool")) == 0 ) {
				  	lrp->lb = strdup("0");
				  	lrp->ub = strdup("1");
		  		} else if ( (strcmp(tmpId->type, "byte")) == 0 ) {
				  	lrp->lb = strdup("0");
				  	lrp->ub = strdup("255");
		  		} else if ( (strcmp(tmpId->type, "short")) == 0 ) {
				  	lrp->lb = strdup("-32767");
				  	lrp->ub = strdup("32767");
		  		} else if ( (strcmp(tmpId->type, "int")) == 0 ) {
				  	lrp->lb = strdup("-2147483647");
				  	lrp->ub = strdup("2147483647");
		  		} else {
		  			// TODO Should limit mtype to the amount of mtypes defined.
		  			
		  			// For chan or mtype
				  	lrp->lb = strdup("0");
				  	lrp->ub = strdup("255");
		  		}
		  	}	


		  	r->parts = lrp;
		  	yyval.r = r;
		  ;
    break;}
case 101:
#line 1392 "spexgram.y"
{
		  	yyval.rp = num_range_append(yyvsp[-2].rp, yyvsp[0].rp);
		  ;
    break;}
case 102:
#line 1398 "spexgram.y"
{
		  	struct lrangepart *lrp;
		  	lrp = calloc(1, sizeof(struct lrangepart));
		  	lrp->lb = yyvsp[0].str;
		  	lrp->ub = lrp->lb;
		  	yyval.rp = lrp;
		  ;
    break;}
case 103:
#line 1406 "spexgram.y"
{
		  	struct lrangepart *lrp;
		  	lrp = calloc(1, sizeof(struct lrangepart));
		  	lrp->lb = yyvsp[-2].str;
		  	lrp->ub = yyvsp[0].str;
		  	yyval.rp = lrp;
		  ;
    break;}
case 104:
#line 1416 "spexgram.y"
{	yyval.al = NULL;	;
    break;}
case 105:
#line 1419 "spexgram.y"
{  	yyval.al = yyvsp[0].al;	;
    break;}
case 106:
#line 1423 "spexgram.y"
{
			struct largs *arg;
			arg = calloc(1, sizeof(struct largs));
			arg->parts = yyvsp[0].ep;
		  	yyval.al = arg;
		  ;
    break;}
case 107:
#line 1432 "spexgram.y"
{
			struct largs *arg;
			
			arg = calloc(1, sizeof(struct largs));
			arg->parts = yyvsp[0].ep;
			yyval.al = args_append(yyvsp[-2].al, arg);
		  ;
    break;}
case 109:
#line 1445 "spexgram.y"
{ yyval.ep = NULL; ;
    break;}
case 112:
#line 1455 "spexgram.y"
{
			struct exprpart *expr;
			
			expr = expr_append(expr_string(")"), yyvsp[0].ep);
			expr = expr_append(args_flatten(yyvsp[-2].al), expr);
			expr = expr_append(expr_string("("), expr);
			expr = expr_append(yyvsp[-4].ep, expr);
			
		  	//expr = expr_append($1, expr_string("("));
		  	//expr = expr_append(expr, args_flatten($3));
		  	//expr = expr_append(expr, expr_string(")"));
		  	//expr = expr_append(expr, $5);
		  	yyval.ep = expr;
		  ;
    break;}
case 113:
#line 1472 "spexgram.y"
{ yyval.ep = NULL; ;
    break;}
case 115:
#line 1478 "spexgram.y"
{ 
		  	yyval.ep = expr_append(yyvsp[-1].ep, yyvsp[0].ep);
		  ;
    break;}
case 117:
#line 1485 "spexgram.y"
{
		  	struct exprpart *prom;
		  	prom = calloc(1, sizeof(struct exprpart));
		  	prom->expr = yyvsp[0].str;
		  	yyval.ep = prom;
		  ;
    break;}
case 118:
#line 1492 "spexgram.y"
{
		  	struct exprpart *prom;
		  	char * mnr;
		  	
		  	prom = calloc(1, sizeof(struct exprpart));
		  	mnr = mtypenr(yyvsp[0].id->name);
		  	if (mnr != NULL)
			  	prom->expr = mnr;
		  	else
			  	prom->id = yyvsp[0].id;
		  	yyval.ep = prom;
		  ;
    break;}
case 124:
#line 1516 "spexgram.y"
{
		  	struct cmp_entry *newEntr;
		  	
		  	newEntr = (struct cmp_entry *) calloc(1, sizeof(struct cmp_entry));

			newEntr->or_op = 1;
			
			newEntr->lhs = yyvsp[-2].cmpe;
			newEntr->rhs = yyvsp[0].cmpe;
			
			yyval.cmpe = newEntr;
		  ;
    break;}
case 126:
#line 1532 "spexgram.y"
{
		  	struct cmp_entry *newEntr;
		  	
		  	newEntr = (struct cmp_entry *) calloc(1, sizeof(struct cmp_entry));

			newEntr->or_op = 0;
			
			newEntr->lhs = yyvsp[-2].cmpe;
			newEntr->rhs = yyvsp[0].cmpe;
			
			yyval.cmpe = newEntr;
		  ;
    break;}
case 127:
#line 1547 "spexgram.y"
{
		  	yyvsp[-1].cmpe->parentheses += 1;
		  	
		  	yyval.cmpe = yyvsp[-1].cmpe;
		  ;
    break;}
case 128:
#line 1553 "spexgram.y"
{
		  	struct cmp_entry *newEntr;
		  	
		  	newEntr = (struct cmp_entry *) calloc(1, sizeof(struct cmp_entry));
		  	newEntr->cmp = yyvsp[0].cmp;
		  	
		  	yyval.cmpe = newEntr;
		  ;
    break;}
case 129:
#line 1566 "spexgram.y"
{
		  	// We need to look only at the first two characters of the operand.
		  	struct compare *cmp;
		  	cmp = malloc(sizeof(struct compare));
		  	cmp->id = yyvsp[-2].id;
		  	cmp->op = op_recognize(yyvsp[-1].str);
		  	cmp->expr = yyvsp[0].ep;
		  	yyval.cmp = cmp;
		  ;
    break;}
case 133:
#line 1583 "spexgram.y"
{
		  	yyvsp[-2].id->str_ind = yyvsp[-1].str;
		  	yyvsp[-2].id->str_part = yyvsp[0].id;
		  	yyval.id = yyvsp[-2].id;
		  ;
    break;}
case 135:
#line 1592 "spexgram.y"
{
		  	yyvsp[-2].id->str_ind = yyvsp[-1].str;
		  	yyvsp[-2].id->str_part = yyvsp[0].id;
		  	yyval.id = yyvsp[-2].id;
		  ;
    break;}
case 138:
#line 1608 "spexgram.y"
{
		  	yyval.id = yyvsp[-3].id;
		  	yyvsp[-3].id->array_index = yyvsp[-1].ep;
		  ;
    break;}
case 139:
#line 1615 "spexgram.y"
{
			struct ident *id;
			id = calloc(1,sizeof(struct ident));
			id->str = NULL;
			id->name = strdup(yyvsp[0].str);
			id->array_index = NULL;
			yyval.id = id;
		  ;
    break;}
case 140:
#line 1627 "spexgram.y"
{
			struct ident *id;
			id = calloc(1,sizeof(struct ident));
			id->str = NULL;
			id->name = strdup(yyvsp[-3].str);
			id->array_index = yyvsp[-1].ep;
			yyval.id = id;
		  ;
    break;}
case 141:
#line 1637 "spexgram.y"
{ 
			struct ident *id;
			id = calloc(1,sizeof(struct ident));
			id->str = strdup(yyvsp[-1].str);
			id->name = strdup(yyvsp[0].str);
			id->array_index = NULL;
			yyval.id = id;
		  ;
    break;}
case 142:
#line 1645 "spexgram.y"
{ 
			struct ident *id;
			id = calloc(1,sizeof(struct ident));
			id->str = strdup(yyvsp[-1].str);
			id->name = strdup(yyvsp[0].str);
			id->array_index = NULL;
			yyval.id = id;
		  ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/Gnu/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1655 "spexgram.y"
		
// Program section

void yyerror(const char *str)
{
        //fprintf(stderr,"error: \"%s\" at token \"%s\" in %s:%d\n",str, yylval.str, file_name, lineno);
        fprintf(stderr,"%s:%d %s at token \"%s\"\n", file_name, lineno, str, yylval.str);
        fatalerr = 1;

}
 
int yywrap()
{
        return 1;
} 
  
int main(void)
{
	file_name = strdup("<stdin>");
        yyparse();
        return fatalerr;
} 

const char *op_recognize(char *op) {
	if(op[0] == '=' && op[1] == '=') {
		return OP_EQ;
	} else if (op[0] == '!' && op[1] == '=') {
		return OP_NEQ;
	} else if (op[0] == '>' && op[1] == '=') {
		return OP_GTEQ;
	} else if (op[0] == '<' && op[1] == '=') {
		return OP_STEQ;
	} else if (op[0] == '>') {
		return OP_GT;
	} else if (op[0] == '<') {
		return OP_ST;
	} else {
		fprintf(stderr, "%s:%d: error: operand was not recognized: %s\n", file_name, lineno, op);
		fatalerr = 1;
		return NULL;
	}
}

const char *dhas_op(const char *op) {
  	if ( op == OP_EQ ) {
		return "DHas";
	} else if ( op == OP_NEQ) {
		return "! DHas";
	} else if ( op == OP_GTEQ) {
		return "DHasGtEq";
	} else if ( op == OP_GT) {
		return "DHasGt";
	} else if ( op == OP_STEQ) {
		return "DHasStEq";
	} else if ( op == OP_ST) {
		return "DHasSt";
	} else {
		return NULL;
	}
}

const char *domain_op(const char *op) {
  	if ( op == OP_EQ ) {
		return "DomainEq";
	} else if ( op == OP_NEQ) {
		return "DomainNEq";
	} else if ( op == OP_GTEQ) {
		return "DomainGtEq";
	} else if ( op == OP_GT) {
		return "DomainGt";
	} else if ( op == OP_STEQ) {
		return "DomainStEq";
	} else if ( op == OP_ST) {
		return "DomainSt";
	} else {
		return NULL;
	}
}	
struct exprpart *expr_append(struct exprpart *list, struct exprpart *part) {
	struct exprpart *cur = NULL;
	
	if ( list == NULL ) {
		return part;
	}
	for(cur = list; cur->next != NULL; cur = cur->next) {
		;
	}
	cur->next = part;
	return list;
	
}

struct exprpart	*expr_string(char *str) {
	struct exprpart *part;
	part = calloc(1, sizeof(struct exprpart));
	part->expr = strdup(str);
	return part;
}

struct exprpart *args_flatten(struct largs *arguments) {
	struct largs *cur_arg = NULL;
	// First part of the expression
	struct exprpart *first_expr = NULL;
	// Last part of the expression
	struct exprpart *cur_expr = NULL;
	// Temporary part when we need to add a ','
	struct exprpart *comma_expr = NULL;
		
	for ( cur_arg = arguments; cur_arg != NULL; cur_arg = cur_arg->next ) {
		if (first_expr == NULL) {
			first_expr = cur_expr = cur_arg->parts;
			while (cur_expr->next != NULL) {
				cur_expr = cur_expr->next;
			}
		} else {
			// Make a expr for the ','
			comma_expr = expr_string(",");
			// Append the comma_expr to the end of our current expr
			expr_append(cur_expr, comma_expr);
			// Append the expression of the current arg
			cur_expr = expr_append(comma_expr, cur_arg->parts);
			while (cur_expr->next != NULL) {
				cur_expr = cur_expr->next;
			}
		}
	}
	return first_expr;
}

struct largs 	*args_append(struct largs *list, struct largs *part) {
	struct largs *cur_arg;
	
	if ( list == NULL ) {
		return part;
	}
	for ( cur_arg = list; cur_arg->next != NULL; cur_arg = cur_arg->next ) {
		;
	}
	cur_arg->next = part;
	return list;
}

struct lrangepart *num_range_append(struct lrangepart *list, struct lrangepart *part) {
	struct lrangepart *cur_part;
	
	if (list == NULL) {
		return part;
	}
	for (cur_part = list; cur_part->next != NULL; cur_part = cur_part->next) {
		;
	}
	cur_part->next = part;
	return list;
}

struct lrange	*lrange_append(struct lrange *list, struct lrange *part) {
	struct lrange *cur_lrange;
	
	if (list == NULL) {
		return part;
	}
	for (cur_lrange = list; cur_lrange->next != NULL; cur_lrange = cur_lrange->next) {
		;
	}
	cur_lrange->next = part;
	return list;
}	

struct largrange	*largrange_append(struct largrange *list, struct largrange *part) {
	struct largrange *cur_largrange;
	
	if (list == NULL) {
		return part;
	}
	for (cur_largrange = list; cur_largrange->next != NULL; cur_largrange = cur_largrange->next) {
		;
	}
	cur_largrange->next = part;
	return list;
}	

void print_ident(struct ident *id, char printStruct) {
	if (printStruct && id->name[0] != '_') {
		if ( id->str) {
			printf("%s", id->str);
		} else {
			print_str(id);
		}
	}
	printf("%s", id->name);
	if(id->array_index) {
		printf("[");
		print_expr(id->array_index, printStruct);
		printf("]");
	}
	if(id->str_part) {
		printf("%s", id->str_ind);
		print_ident(id->str_part, 0);
	}
}
void print_str(struct ident *id) {
	IdEntry *tmpId;
	
	// If we can find the identifier in the list of global identifiers,
	// we will print it with "now."
	for (tmpId = glIds; tmpId != NULL; tmpId = tmpId->next) {
		if ( (strcmp(id->name, tmpId->label)) == 0 ) {
			printf("now.");
			return;
		}
	}
	// Otherwise, we print it with the current proctype (P..->)
	printf("P%s->", last_proctype);	
}
void print_expr(struct exprpart *expression, char printStruct) {
	struct exprpart *cur_expr;
	
	for(cur_expr = expression; cur_expr != NULL; cur_expr = cur_expr->next) {
		if(cur_expr->id) {
			print_ident(cur_expr->id, printStruct);
		} else if (cur_expr->expr) {
			printf("%s", cur_expr->expr);
		}
	}
}
	
void print_cmpe_cond(struct cmp_entry *cmpe, char c_prefix) {
	int i;

	if ( c_prefix ) {
		printf("c_expr { (");
	}
	for (i = cmpe->parentheses; i > 0; i--) {
		printf("(");
	}

	if ( cmpe->cmp ) {
		print_cmp_cond(cmpe->cmp);
	} else {
		print_cmpe_cond(cmpe->lhs, 0);
		printf(" %s ", cmpe->or_op ? "||" : "&&");
		print_cmpe_cond(cmpe->rhs, 0);
	}

	for (i = cmpe->parentheses; i > 0; i--) {
		printf(")");
	}
	
	if ( c_prefix ) {
		printf(") }");
	}
}

void print_cmpe_eff(struct cmp_entry *cmpe, char c_prefix) {
	if ( c_prefix ) {
		printf("c_code {");
	}

	if ( cmpe->cmp ) {
		print_cmp_eff(cmpe->cmp);
	} else {
		print_cmpe_or_eff(cmpe);
	}
	
	if ( c_prefix ) {
		printf("}");
	}
}

void print_cmpe_or_eff(struct cmp_entry *cmpe) {
	if ( ! cmpe->or_op ) {
		print_cmpe_and_eff(cmpe);
	} else {
		printf("if (");
		print_cmpe_cond(cmpe->lhs, 0);
		printf(") {\n");
		print_cmpe_eff(cmpe->lhs, 0);
		printf("\n} else if (");
		print_cmpe_cond(cmpe->rhs, 0);
		printf(") {\n");
		print_cmpe_eff(cmpe->rhs, 0);
		printf("\n}");
	}
}

void print_cmpe_and_eff(struct cmp_entry *cmpe) {
	print_cmpe_eff(cmpe->lhs, 0);
	printf("\n");
	print_cmpe_eff(cmpe->rhs, 0);
	printf("\n");	
}

void print_cmpe(struct cmp_entry *cmpe) {
	int i;
	
	for (i = cmpe->parentheses; i > 0; i--) {
		printf("(");
	}
	
	if ( cmpe->cmp ) {
		print_cmp(cmpe->cmp, 0);
	} else {
		print_cmpe(cmpe->lhs);
		printf(" %s ", cmpe->or_op ? "||" : "&&");
		print_cmpe(cmpe->rhs);
	}
	
	for (i = cmpe->parentheses; i > 0; i--) {
		printf(")");
	}
	
}

void print_cmp(struct compare *cmp, char printStruct) {
	print_ident(cmp->id, printStruct);
	printf(" %s ", cmp->op);
	print_expr(cmp->expr, printStruct);
}
void print_cmp_cond(struct compare *cmp) {

	printf("%s(", dhas_op(cmp->op));
	print_ident(cmp->id, 1);
	printf(", (");
	print_expr(cmp->expr, 1);
	printf("))");
}
void print_cmp_eff(struct compare *cmp) {
	
	print_ident(cmp->id, 1);
	printf(" = %s(", domain_op(cmp->op));
	print_ident(cmp->id, 1);
	printf(", (");
	print_expr(cmp->expr, 1);
	printf("));");
}

IdEntry *findId(char *name) {
	IdEntry *tmpId = NULL;

  	for ( tmpId = glIds; tmpId != NULL; tmpId = tmpId->next ) {
  		if ( (strcmp(name, tmpId->label)) == 0 ) {
  			break;
  		}
  	}
  	if (tmpId == NULL) {
	  	for ( tmpId = localIds; tmpId != NULL; tmpId = tmpId->next ) {
	  		if ( (strcmp(name, tmpId->label)) == 0 ) {
	  			break;
	  		}
	  	}
  	}
	
	return tmpId;
}

int isRangeBetween(struct lrangepart *lrp, int lb, int ub) {
	long rangeVal;
	
	if (lrp == NULL) {
		return 0;
	}
	
	rangeVal = strtol(lrp->lb, NULL, 0);
	if ( rangeVal < lb ) {
		return 0;
	}
	
	// find last rangepart
	for ( ; lrp->next != NULL; lrp = lrp->next ) {
		;
	}
	
	rangeVal = strtol(lrp->ub, NULL, 0);
	if ( rangeVal > ub ) {
		return 0;
	}

	return 1;
}

char * mtypenr(char *s)
{
	struct mtypelist *ol;
	

	if (mtypes == NULL) {
		if (0) fprintf(stderr, "ismtype(%s) 0\n", s);
		return NULL;
	}
		
	for ( ol = mtypes; ol != NULL; ol = ol->next ) {
		  if (strcmp(ol->label, s) == 0) {
			if (0) fprintf(stderr, "ismtype(%s) %s\n", s, ol->intrepr);
		  	return ol->intrepr;
		  }
	}
	
	if (0) fprintf(stderr, "ismtype(%s) 0\n", s);
	return NULL;
}

struct stringlist *findchantypes(char *s)
{
	struct chandecllist *l;
	

	if (channels == NULL)
		return NULL;
		
	for ( l = channels; l != NULL; l = l->next ) {
		  if (strcmp(l->chan, s) == 0){
			if(0) fprintf(stderr,"findchantypes(%s): trying: (%s) : 1\n", s, l->chan);
		  	return l->types;
		  } else {
			if(0) fprintf(stderr,"findchantypes(%s): trying: (%s) : 0\n", s, l->chan);
		  }
	}
	if(0) fprintf(stderr,"findchantypes(%s): nada\n", s);
	
	return NULL;
}

/* End of file */
