# =========================================================================
# $Id: em.tcl,v 1.1.2.8 2000/09/06 16:26:24 belinfan Exp $
# =========================================================================

proc valcmp { v1 v2 } {
	return [string compare [string tolower $v1] [string tolower $v2]]
}

proc poscmp { p1 p2 } {
	return [poscmp_for_lists $p1 $p2]
}

proc poscmp_for_strings { p1 p2 } {
	return [string compare $p1 $p2]
}

proc poscmp_for_lists { p1 p2 } {
	set l1 [llength $p1]
	set l2 [llength $p2]
	set i1 0
	set i2 0
	while { ($i1 < $l1) && ($i2 < $l2) } {
		if {$p1 < $p2} {
			return -1
		} elseif  {$p1 > $p2} {
			return 1
		} else {
				incr i1
				incr i2
		}
	}
	if {$l1 < $l2} {
		return -1
	} elseif  {$l1 > $l2} {
		return 1
	} else {
		return 0
	}
}

proc targetcmp {t1 t2} {
	return [valcmp $t1 $t2]
}

proc getpos {item pos} {
	return [path2operator $item [join $pos .]]
}

proc getarity {item pos} {
	return [path2arity $item [join $pos .]]
}

#proc gettuple {item pos} {
#	global pt
#	if {($item != $pt(item)) || ($pos != $pt(pos))} {
#		set pt(item) $item
#		set pt(pos) $pos
#		set pt(tuple) [path2tuple $item [join $pos .]]
#	}
#	return $pt(tuple)
#}
#proc getpos {item pos} {
#	return [lindex [gettuple $item $pos] 0]
#}
#
#proc getarity {item pos} {
#	return [lindex [gettuple $item $pos] 1]
#}



proc mk_pattern {s} {
	set t [event2term $s]
	set res {}
	visit $t op m  p res a t {
		# debugMsg "$op $m $p"
		set pos [split $p .]
		set l [llength $pos]
		set prefix [lrange $pos 0 [expr $l - 2]]
		if {[string compare $m enter] == 0} {
			set a($pos) 0
			if {![info exists a($prefix)]} {
				set a($prefix) 0
			}
			incr a($prefix)
			if {[string compare $op *] != 0} {
				lappend res [list n $pos $op]
				# debugMsg "rule: [list n $pos $op]"
			}
		} else {
			if {[string compare $op *] != 0} {
				lappend res [list a $pos $a($pos)]
				# debugMsg "rule: [list a $pos $a($pos)]"
			} elseif {$a($pos) > 0} {
				lappend res [list a $pos $a($pos)]
				# debugMsg "rule: [list a $pos $a($pos)]"
			}
		}
		set t $a()
		# debugMsg "($pos):$a($pos) ; ($prefix):$a($prefix)"
	}
	lappend res [list a {} $t]
	# debugMsg "rule: [list a {} $t]"
	return $res
}

#tm_init poscmp valcmp targetcmp
#set res [mk_pattern "udp_in!*!*"]
#tm_add_pattern $res aap
#tm_match [event2term "udp_in!aap!nn"] getpos

proc em_init {} {
	return [tm_init poscmp valcmp targetcmp]
}
proc em_list {} {
	return [tm_list]
}
proc em_add_pattern {s t} {
	set pat [mk_pattern $s]
	# debugMsg "em_add_pattern ($pat) ($t)"
	return [tm_add_pattern $s $pat $t]
}
proc em_find_string {s} {
	set res [em_find_term [event2term $s]]
	# debugMsg "em_find_string ($s): ($res)"
	return $res
}
proc em_find_term {t} {
	return [tm_match $t getpos getarity]
}
proc em_compile {} {
	return [tm_compile]
}
