#! @EXPECT@ --
#! /Utils/bin/expect --
#! /usr/local/bin/expect --
#
# $Id: expnohup.sh,v 1.1.2.2 2005/07/13 21:40:23 belinfan Exp $
#
# (c) 2004-2005 Axel.Belinfante@cs.utwente.nl
# Feel free to use, update or redistribute as long as no monies are exchanged.
# Please report fixes/improvements back to me.
#
# To use, make one change above:
#   - replace @EXPECT@ by the path to your expect interpreter
#   - make sure that the companion script anifsmsrv can be found
#      (is in your PATH)
#
# NOTE: this script does need expect.
# It is like nohup - but without capturing the output in a file nohup.out.
# It's a hack and I'd rather not use it.
# It seems to get the job done, though.

# exp_internal 1
log_user 0

trap {} HUP

set cmd [concat spawn $argv ]

if {[catch $cmd foo]} {
	catch {puts stderr "spawn fails: $foo"}
	exit 1
}

expect_background {
	eof {
		set quit 1
		exit
	}
	-re "(\[^\r\n]*)\r*\n" {
		set l $expect_out(1,string)
		send_error "$l\n"
	}
}
vwait quit
exit
