#! @PERL@

# Experimental.
# usage: autsimplify < file.aut > simpler.aut

# sed 's/".*\(@[0-9]*\)"/"\1"/' < confprot-0.sim.dot > confprot-0.simpp.dot


while(<>) {
	chomp;
	if (/^des[ 	]*\(([0-9]+)[ 	]*,[ 	]*([0-9]+)[ 	]*,[ 	]*([0-9]+)[ 	]*\)/)  {
		$ini = $1;
		$nnodes = $2;
		$nedges = $3;
	} elsif (/^\([ 	]*([0-9]+)[ 	]*,[ 	]*(.*)[ 	]*,[ 	]*([0-9]+)[ 	]*\)$/) {
		$s = $1;
		$l = $2;
		$d = $3;
		if ($l =~ /^"(.*)"$/) {
			$l = $1;
		} elsif ($l =~ /^'(.*)'$/) {
			$l = $1;
		}
		$in{$d}++;
		$out{$s}++;
		$n{$s} = 1;
		$n{$d} = 1;
		push(@trans, join($;, ($s, $l, $d)));
	}
}

# subconsiencly we know $ini == 0
# and we depend on it here, I think,
# or at least on the fact that we know that
# there can be a node 0

$outnodes = $nnodes;
$outedges = $nedges;
@outtrans = ();

$ll = '';
$ss = '';
$dd = '';
foreach $t (sort bysrc @trans) {
	($s, $l, $d) = split($;, $t);
#	print STDERR "SRC $s\n";
	if ($in{$s} == 1 && $out{$s} == 1 &&
	    $in{$d} == 1 && $out{$d} == 1 &&
	    ($ll eq '' || $s == $dd)) {
	    if ($ll eq '') {
			$ss = $s;
	    } else {
			$ll .= '\\n';
			$outnodes--;
			$outedges--;
		}
		$ll .= $l;
		$dd = $d;
	} else {
		if ($ll ne '') {
			push(@outtrans, '('.$ss.', "'.$ll.'", '.$dd.')');
			$ll = '';
			$ss = '';
			$dd = '';
		}
		push(@outtrans, '('.$s.', "'.$l.'", '.$d.')');
	}
}

print STDERR "nodes: $nnodes -> $outnodes; edges: $nedges -> $outedges\n";
print "des($ini, $outnodes, $outedges)"."\n";
foreach $t (@outtrans) {
	print $t."\n";
}

sub bysrc {
	my($sa, $la, $da) = split($;, $a);
	my($sb, $lb, $db) = split($;, $b);
    return $sa <=> $sb;
}
