#! @PERL@

$debug = 0;

$| = 1; # do not buffer!


initialize();

while(<>) {
	chomp;
	/^ABSTRACT/ && do handle_action($_ , 0);
}

finalize();

sub initialize {
}

sub handle_config {
	my($line) = @_;
	print STDERR "line: ($line) " if $debug;
	my(@words) = split(/ /, $line);
	my($ignore, $keyword);
	print STDERR "words: (@words) " if $debug;
	$ignore = shift(@words); # shift out CONFIG
	$keyword = shift(@words); # shift out config keyword
	if ($keyword eq "CONFIGFILE") {
		$cfgfilename = shift(@words);
		$cfgfilename =~ s/\.if$//;
		print STDERR "msc ($cfgfilename) " if $debug;
		$result = 'msc ';
		$result .= $cfgfilename.';';
		$result .= "\n";
		print $result;
	}
}

sub handle_action {
	my($line, $expected) = @_;
	print STDERR "line: ($line) " if $debug;
	my(@words) = split(/ /, $line);
	my($ignore, $stepnr, $iokind_chan_pco, $suspension, $action,
	   $iokind,$chan_pco_opt, $chan_pco, $chan, $pco, $inst);
	$ignore = shift(@words); # shift out ABSTRACT
	$stepnr = shift(@words);
	$iokind_chan_pco = shift(@words);
	$suspension = pop(@words);
	$suspension = strip_parentheses($suspension);
	$action = join(" ", @words);
	$action = strip_parentheses($action);
	if ($iokind_chan_pco =~ /^(input|output)(\(([^\)]*)\))?$/) {
		$iokind=$1;
		$chan_pco_opt = $2;
		$chan_pco = $3;
		if ($chan_pco =~ /^([^:]+):([^:]+)$/) {
			$chan = $1;
			$pco = $2;
			add_nonsuspension($stepnr, $iokind, $action, $chan );
		} elsif ($chan_pco =~ /^([^:]+)$/) {
			$chan = $1;
			$pco = '';
			$inst = '('.$chan.')';
			if ($suspension eq "1") {
				add_suspension($stepnr, $iokind, $action, $chan );
			} else {
				msg("warning: no pco for non-suspension action nr: $stepnr");
				add_nonsuspension($stepnr, $iokind, $action, $chan );
			}
		} else {
			$chan = '';
			$pco = '';
			$inst = 'tester';
			if ($suspension eq "1") {
				add_suspension($stepnr, $iokind, $action, $chan);
			} else {
				add_nonsuspension($stepnr, $iokind, $action, $chan );
			}
		}
	} else {
		msg("parse error: could not parse iokind/channel/pco for action nr: $stepnr");
	}
}

sub add_suspension {
	my($stepnr, $iokind, $action, $chan) = @_;
	print STDERR "add_suspension ($stepnr, $iokind)" if $debug;
	if ($iokind eq "input") {
		print "C_INPUT suspension=1\tchannel=$chan\n";
	} elsif ($iokind eq "output") {
		print "C_OUTPUT suspension=1\tchannel=$chan\n";
	} else {
		msg("unknown action kind \"$iokind\" for nr: $stepnr");
	}
}
sub add_nonsuspension {
	my($stepnr, $iokind, $action) = @_;
	my($i, $iut, $actpfx);
	print STDERR "add_nonsuspension ($stepnr, $iokind, $action)" if $debug;
	if ($iokind eq "input") {
		print "C_INPUT event=$action\tsuspension=0\n";
	} elsif ($iokind eq "output") {
		print "C_OUTPUT event=$action\tsuspension=0\n";
	} else {
		msg("unknown action kind \"$iokind\" for nr: $stepnr");
	}
}

sub finalize {
}


sub msg {
	my($s) = @_;
	print STDERR "log2msc: ".$s."\n";
}

sub strip_parentheses {
	my($s) = @_;
	if ($s =~ /^\((.*)\)$/) {
		return $1;
	} else {
		return $s;
	}
}

sub strip_quotes {
	my($s) = @_;
	if ($s =~ /^"(.*)"$/) {
		return $1;
	} else {
		return $s;
	}
}
